package com.yihu.quota.etl.formula;

import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import java.lang.reflect.Method;
import java.util.List;
import java.util.Map;

/**
 * @author janseny
 * @date 2018/10/9
 * 函数计算转换器
 */
@Component
@Scope("prototype")
public class FuncHelper {

    public Object function(String classPackage,Object... args) throws Exception {
        Object data = null;
        String clazz = classPackage;
        if (!StringUtils.isEmpty(classPackage)) {
            //反射出对象并且调用execute方法去 计算对应的值
            Object obj = Class.forName(clazz).newInstance();
            Method method = obj.getClass().getMethod("execute", Object.class);
            data = (List<Map<String, Object>>) method.invoke(obj, args);
        }
        return data;
    }
}
