package com.yihu.quota.dao.dimension;

import com.yihu.quota.model.dimension.DimensionMember;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.transaction.annotation.Transactional;

/**
 * Created by wxw on 2018/9/7.
 * @author wxw
 */
public interface DimensionMemberDao extends PagingAndSortingRepository<DimensionMember, Integer> {

    @Modifying
    @Transactional
    @Query("delete from DimensionMember where dimensionId = :dimensionId")
    void deleteByDimensionId(@Param("dimensionId") Integer dimensionId);
}
