package com.yihu.quota.service.source;

import com.yihu.ehr.query.BaseJpaService;
import com.yihu.quota.dao.source.DataSourcesTableDao;
import com.yihu.quota.dao.source.DataSourcesTableFieldDao;
import com.yihu.quota.model.source.DataSourcesTable;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Created by wxw on 2018/9/10.
 *
 * @author wxw.
 */
@Service
public class DataSourcesTableService extends BaseJpaService<DataSourcesTable, DataSourcesTableDao> {

    @Autowired
    private DataSourcesTableDao dataSourcesTableDao;

    @Autowired
    private DataSourcesTableFieldDao dataSourcesTableFieldDao;

    public void deleteById(Integer id) {
        dataSourcesTableDao.delete(id);
        // 删除属于该数据源表对应的字段对应表
        dataSourcesTableFieldDao.deleteByTableId(id);
    }
}
